unit gui;

interface

uses proboj0;

type
  state = array[0..255] of byte;

type
  plstat = record
    meno:string;
    body:longint;
    vojakov:integer;
    statov:integer;
    zon:integer;
    color:longint;
    vyrobil:integer;
    znicil:integer;
  end;
  statistics = record
    pl : array[1..MAX_PLAYERS] of plstat;
    kolo:integer;
  end;

var
  gui_mapa : array[0..69, 0..79] of byte;
  stat : statistics;
  statmax : statistics;

const
  labels : boolean = false;
  internal_colors = 5;



procedure gui_startup;
procedure gui_shutdown;
procedure gui_reset;
procedure gui_conquer(w : integer; c:integer);
procedure gui_message(who:string; what:string; color:integer);
procedure gui_prepare_attack(z,n:byte);
procedure gui_prepare_move(z,n:byte);
procedure gui_prepare_pridaj(n:byte);
procedure gui_update_stat(pl:integer);
procedure gui_update_rect(x1,y1,x2,y2:integer);
procedure gui_sprite_set(no,x,y:integer);
procedure gui_sprite_upd(no:integer; s:string);
procedure gui_sprite_upd_ex(no,x,y:integer;s:string);
procedure gui_sprite_start;
procedure gui_sprite_end;
procedure gui_sprite_hide(no:integer);
procedure gui_sprite_show(no:integer);
procedure gui_sprite_show_all;
procedure gui_set_level(l:integer);
procedure gui_next_turn;
procedure gui_total_update;
procedure gui_total_summary(pl:integer);
procedure gui_summary(pl:integer);

implementation

uses graph, crt;

const MSGY = 370;

var
  actual_state : state;
  ostat : statistics;


const

  LEVEL_SUPERFAST = 0;
  LEVEL_FAST = 1;
  LEVEL_STD = 2;
  LEVEL_SLOW = 3;
  LEVEL_SUPERSLOW = 4;

  gui_level:integer = LEVEL_STD;

  C_BLACK      = 0;
  C_BACKGROUND = 1;
  C_LIGHTGRAY  = 2;
  C_WHITE      = 3;
  C_GRAY       = 4;

  unassigned = C_GRAY + $80;
  sea = C_BACKGROUND + $80;


var
  ux1,uy1,ux2,uy2:integer;


procedure add_pt(x,y:integer);
begin
  if (ux1=-1) then begin
    ux1:=x; uy1:=y; ux2:=x; uy1:=y;
  end else begin
    if x<ux1 then ux1:=x;
    if x>ux2 then ux2:=x;
    if y<uy1 then uy1:=y;
    if y>uy2 then uy2:=y;
  end;
end;

type arr = array[1..MAX_PLAYERS] of longint;

procedure bbar(x1,y1,x2,y2:integer;s,c:arr);
var sm,ss:longint;
    i :integer;
    len:longint;
    x,xx:integer;
begin
  sm:=0;
  len:=x2-x1;
  for i:=1 to MAX_PLAYERS do
    inc(sm, s[i]);

  x:=x1;
  ss:=0;
  for i:=1 to MAX_PLAYERS do begin
    inc(ss,s[i]);
    setfillstyle(1,c[i]);
    xx:=(longint(len)*ss) div sm;
    if (x+1<xx) then bar(x+1,y1,xx,y2);
    x:=xx;
  end;
end;

procedure gui_reset;
var i:integer;
begin
  setfillstyle(8,C_BACKGROUND);
  bar(0,0,640,480);

  setfillstyle(1,C_BLACK);
  bar(10, MSGY, 630,470);

  setfillstyle(1,C_BLACK);
  bar(10, 10, 410,360);

  bar(420,10,630,360);

  for i:=0 to 127 do begin
    if (i<>ord('.')) then
      gui_conquer(i, unassigned)
    else
      gui_conquer(i, sea);
  end;

  fillchar(ostat, sizeof(ostat), 1);
  fillchar(stat, sizeof(stat), 0);
  fillchar(statmax, sizeof(statmax), 0);
end;

procedure gui_prepare_attack(z,n:byte);
var f, t:byte;
var i:integer;
begin
  f:=actual_state[z];
  t:=actual_state[n];
  if gui_level>=LEVEL_STD then
    for i:=1 to 3 do begin
      gui_conquer(z, C_WHITE or $80);
      gui_conquer(n, C_BLACK or $80);
      if gui_level>=LEVEL_SLOW then delay(80);
      gui_conquer(z, f);
      gui_conquer(n, t);
      if gui_level>=LEVEL_SLOW then delay(80);
    end;

  gui_conquer(z, f);
  gui_conquer(n, t);
end;

procedure gui_prepare_move(z,n:byte);
var f, t:byte;
var i:integer;
begin
  f:=actual_state[z];
  t:=actual_state[n];
  if gui_level>=LEVEL_STD then
    for i:=1 to 3 do begin
      gui_conquer(z, C_BACKGROUND or $80);
      gui_conquer(n, C_BACKGROUND or $80);
      if gui_level>=LEVEL_SLOW then delay(80);
      gui_conquer(z, f);
      gui_conquer(n, t);
      if gui_level>=LEVEL_SLOW then delay(80);
    end;

  gui_conquer(z, f);
  gui_conquer(n, t);
end;

procedure gui_prepare_pridaj(n:byte);
var f, t:byte;
var i:integer;
begin
  t:=actual_state[n];
  if gui_level>=LEVEL_STD then
    for i:=1 to 3 do begin
      gui_conquer(n, C_LIGHTGRAY or $80);
      if gui_level>=LEVEL_SLOW then delay(80);
      gui_conquer(n, t);
      if gui_level>=LEVEL_SLOW then delay(80);
    end;

  gui_conquer(n, t);
end;


procedure gui_startup;
var gd,gm:integer;
    i:integer;
begin

  gd := VGA;
  gm := VGAHi;

  initgraph(gd,gm,'drv');
  if (graphresult<>0) then
    begin
      writeln('GUI: Nemozem inicializovat grafiku');
      halt(1);
    end;
  { init basic colors }

  SetRGBPalette(C_BLACK, 0, 0, 0);
  SetRGBPalette(C_BACKGROUND, 12, 28, 120);
  SetRGBPalette(C_LIGHTGRAY, 120, 120, 120);
  SetRGBPalette(C_WHITE, 255, 255, 255);
  SetRGBPalette(C_GRAY, 73, 23, 11);

{  gui_reset;}
end;


procedure gui_shutdown;
begin
  closegraph;
end;

procedure gui_update(i,j:integer);
var c:byte;
begin
  c:= actual_state[gui_mapa[j][i]];

  if (c and $80<>0) then setfillstyle(1,c and $7f)
  else setfillstyle(1,c + INTERNAL_COLORS);

  setcolor(C_BLACK);
  bar(10+i*5, 10+j*5,10+i*5+4, 10+j*5+4);
  { check hranice }
  if (i<79) then
    if (gui_mapa[j][i]<>gui_mapa[j][i+1]) then
      line(10+i*5+4,10+j*5,10+i*5+4,10+j*5+4);
  if (j<69) then
    if (gui_mapa[j][i]<>gui_mapa[j+1][i]) then
      line(10+i*5,10+j*5+4,10+i*5+4,10+j*5+4);

end;

procedure gui_conquer(w : integer; c:integer);
var i,j:integer;
begin
  actual_state[w]:=c;

  if (gui_level=LEVEL_SUPERFAST) then exit;

  setviewport(0,0,getmaxx, getmaxy, false);

  if (c and $80<>0) then setfillstyle(1,c and $7f)
  else setfillstyle(1,c+INTERNAL_COLORS);

  setcolor(C_BLACK);
  for j:=0 to 69 do
    for i:=0 to 79 do
      if (gui_mapa[j][i]=w) then begin
        add_pt(10+i*5, 10+j*5);
        add_pt(10+i*5+4, 10+j*5+4);
        bar(10+i*5, 10+j*5,10+i*5+4, 10+j*5+4);
        { check hranice }
        if (i<79) then
          if (gui_mapa[j][i]<>gui_mapa[j][i+1]) then
            line(10+i*5+4,10+j*5,10+i*5+4,10+j*5+4);
        if (j<69) then
          if (gui_mapa[j][i]<>gui_mapa[j+1][i]) then
            line(10+i*5,10+j*5+4,10+i*5+4,10+j*5+4);
      end;
  setcolor(C_WHITE);
  gui_sprite_show(w);
end;



var ViewX, ViewY:integer;
procedure _setviewport(x1,y1,x2,y2:integer; clip:boolean);
begin
  setviewport(x1,y1,x2,y2,clip);
  ViewX:=x2-x1;
  ViewY:=y2-y1;
end;


procedure gui_message(who:string; what:string; color:integer);
var h:integer;
    p:pointer;
begin
  { scroll message box }
  settextstyle(SMALLFONT, 0, 6);
  h := textheight('H')+3;

  _setviewport(10,MSGY,630,470,CLIPon);

  { scroll ... }

  getmem(p, imagesize(0,0,ViewX,ViewY-h));
  if (p<>nil) then begin
    getimage(0,h,ViewX,ViewY,p^);
    putimage(0,0,p^,NormalPut);

    freemem(p, imagesize(0,0,ViewX,ViewY-h));
  end;

  setfillstyle(1,C_BLACK);
  bar(0,ViewY-h,ViewX,ViewY);


  setcolor(C_LIGHTGRAY);
  outtextxy(5,ViewY-h, who);
  if (color and $80<>0) then setcolor(color and $7f)
  else setcolor(color + INTERNAL_COLORS);
  outtextxy(5+textwidth(who)+5,ViewY-h, what);
end;


procedure gui_update_stat(pl:integer);
var i:integer;
    h:integer;
    s:string;
    ind:integer;

    st, c:arr;

procedure cln(i:integer);
begin
  bar(0,h*i,ViewY,h*i+h-1);
end;

function max(i1,i2,i3,i4:integer):integer;
begin
  if (i2>i1) then i1:=i2;
  if (i4>i3) then i3:=i4;
  if (i3>i1) then i1:=i3;
  max:=i1;
end;

function max2(a,b:integer):integer;
begin
  if a>b then max2 := a else max2 := b;
end;

begin
  setcolor(C_WHITE);

  for i:=1 to MAX_PLAYERS do begin
    c[i] := 0; st[i]:=0;
  end;

  for i:=1 to pl do begin
    c[i] := INTERNAL_COLORS-1+i;
    if (ostat.pl[i].color <> stat.pl[i].color)
      then begin
        SetRGBPalette(i+INTERNAL_COLORS-1, (stat.pl[i].color div 65536) and 255,
           (stat.pl[i].color div 256) and 255, (stat.pl[i].color) and 255);
      end;
  end;

  _setviewport(420,10,630,360,CLIPON);

  setfillstyle(1,C_BLACK);

  settextstyle(SMALLFONT, 0, 6);

  h := textheight('H')+3;

  outtextxy(5,5+0*h,'Vojakov');
  for i:=1 to pl do st[i]:=1+stat.pl[i].vojakov;
  bbar(7,5+1*h,viewx-5,5+2*h-4,st,c);
  outtextxy(5,5+2*h,'Statov');
  for i:=1 to pl do st[i]:=1+stat.pl[i].statov;
  bbar(7,5+3*h,viewx-5,5+4*h-4,st,c);
  outtextxy(5,5+4*h,'Zon');
  for i:=1 to pl do st[i]:=1+stat.pl[i].zon;
  bbar(7,5+5*h,viewx-5,5+6*h-4,st,c);

  for i:=1 to pl do begin
    if (stat.pl[i].meno<>ostat.pl[i].meno) then begin
      setfillstyle(1,C_BLACK);
      bar(5,10+6*h+i*h-h,viewx,10+6*h+i*h);
      setcolor(INTERNAL_COLORS + i-1);
      outtextxy(5,10+6*h+i*h-h,stat.pl[i].meno);
      ostat.pl[i].body:=-1;
    end;
    if (stat.pl[i].body<>ostat.pl[i].body) then begin
      str(stat.pl[i].body,s);
      setcolor(C_LIGHTGRAY);
      setfillstyle(1,C_BLACK);
      bar(viewx-textwidth(s)-5,10+6*h+i*h-h,viewx,10+6*h+i*h);
      outtextxy(viewx-textwidth(s)-5,10+6*h+i*h-h, s);
    end;
  end;

  { upd kolo }
  str(stat.kolo,s);
  setcolor(C_LIGHTGRAY);
  setfillstyle(1,C_BLACK);
  bar(0,viewy-H,viewx,viewy);
  outtextxy(viewx-textwidth(s)-5,viewy-H, s);


  _setviewport(0,0,getmaxx,getmaxy,false);

  if (gui_level = LEVEL_SUPERFAST) and (stat.kolo mod 50 = 0)
    then gui_total_update;

  for i:=1 to pl do begin
    statmax.pl[i].vojakov := max2(statmax.pl[i].vojakov, stat.pl[i].vojakov);
    statmax.pl[i].statov := max2(statmax.pl[i].statov, stat.pl[i].statov);
    statmax.pl[i].zon := max2(statmax.pl[i].zon, stat.pl[i].zon);
    statmax.pl[i].vyrobil := max2(statmax.pl[i].vyrobil, stat.pl[i].vyrobil);
    statmax.pl[i].znicil := max2(statmax.pl[i].znicil, stat.pl[i].znicil);
  end;


  ostat := stat;
end;

procedure gui_update_rect(x1,y1,x2,y2:integer);
var i,j:integer;
begin
  x1 := ((x1-10) div 5);
  x2 := ((x2-5) div 5);
  y1 := ((y1-10) div 5);
  y2 := ((y2-5) div 5);

  if (x2>79) then x2:=79;
  if (y2>69) then y2:=69;

  if (x1<0) or (y1<0) or (x2>80) or (y2>70) then exit;

  for j:=y1 to y2 do
    for i:=x1 to x2 do
      gui_update(i,j);
end;

type
  sprite_rec = record
    x,y:integer;
    x1,y1,x2,y2:integer;
    ptr:string[5];
  end;

var
  sprites : array[0..255] of sprite_rec;

procedure gui_sprite_set(no,x,y:integer);
begin
  sprites[no].x:=x*5+15;
  sprites[no].y:=y*5+15;
  sprites[no].x1:=-1;
  sprites[no].ptr := 'N';
end;

procedure gui_sprite_hide(no:integer);
begin
  if (gui_level=LEVEL_SUPERFAST) then exit;
  with sprites[no] do begin
    if (x=-1) then exit;
    if (x1<>-1) then
      gui_update_rect(x1,y1,x2,y2);
  end;
end;

function inrect(x1,y1,x2,y2,a,b:integer):boolean;
begin
  inrect:=(x1<=a)and(a<=x2)and
          (y1<=b)and(b<=y2);
end;

procedure gui_sprite_show_all_in(_x1,_y1,_x2,_y2:integer);
var i:integer;
begin
  if (gui_level=LEVEL_SUPERFAST) then exit;
  for i:=0 to 255 do
    with sprites[i] do begin
      if inrect(_x1,_y1,_x2,_y2,x1,y1) or
         inrect(_x1,_y1,_x2,_y2,x2,y2) then gui_sprite_show(i);
    end;
end;

procedure gui_sprite_show_all;
begin
  if (ux1=-1) then exit;

  gui_sprite_show_all_in(ux1,uy1,ux2,uy2);

  ux1:=-1;
end;

procedure gui_sprite_show(no:integer);
var u,v:integer;
begin
  if (gui_level=LEVEL_SUPERFAST) then exit;
  settextstyle(SMALLFONT, 0, 5);
  setcolor(C_BLACK);
  with sprites[no] do begin
    if (x=-1) then exit;
    u:=textwidth(ptr); u:=(u+1) div 2;
    v:=textheight(ptr);v:=(v+1) div 2;
    x1:=x-u; x2:=x+u;
    y1:=y-v; y2:=y+v;
    if (x1<10) then begin
      inc(x2,10-x1);
      x1:=10;
    end;
    if (y1<10) then begin
      inc(y2,10-y1);
      y1:=10;
    end;
    if (x2>409) then begin
      dec(x1,x2-409);
      x2:=409;
    end;
    if (y2>359) then begin
      dec(y1,y2-359);
      y2:=359;
    end;
    outtextxy(x1,y1,ptr);
{    rectangle(x1,y1,x2,y2);}
  end;
end;



procedure gui_sprite_upd(no:integer; s:string);
begin
  _setviewport(0,0,getmaxx,getmaxy,false);
  gui_sprite_hide(no);
  sprites[no].ptr := s;
  gui_sprite_show(no);
end;

procedure gui_sprite_upd_ex(no,x,y:integer;s:string);
begin
  gui_sprite_hide(no);
  sprites[no].ptr := s;
  sprites[no].x := x*5+15;
  sprites[no].y := y*5+15;
  gui_sprite_show(no);
end;

procedure gui_sprite_start;
begin
end;

procedure gui_sprite_end;
begin
end;

procedure gui_set_level(l:integer);
begin
  if (gui_level=LEVEL_SUPERFAST) then gui_total_update;
  gui_level := l;
end;

var tm:longint;         { na zabezpecenie, ze tah trva aspon 1/18 sekundy }

procedure gui_next_turn;
var i:integer;
    t:longint;
begin
  if (gui_level>LEVEL_FAST) then begin
    repeat
      t:=meml[0:$46c];
    until t<>tm;
    tm:=t;
  end;
  if (gui_level>=LEVEL_SUPERSLOW) then readkey;
end;

procedure gui_total_update;
var i:integer;
begin
  if (gui_level<>LEVEL_SUPERFAST) then exit;
  gui_level := LEVEL_FAST;

  for i:=0 to 127 do begin
    if (i<>ord('.')) then
      gui_conquer(i, actual_state[i])
    else
      gui_conquer(i, sea);
  end;

  gui_sprite_show_all_in(0,0,640,480);

  gui_level := LEVEL_SUPERFAST;
end;

procedure gui_summary(pl:integer);
var i:integer;
    tmax,j:integer;
    s:string;

procedure xbar(x,y:integer; c, n:integer);
begin
  if n=0 then n:=1;
  setfillstyle(1,C_BACKGROUND);
  bar(x,y+2, x+(longint(ViewX-x-20)*c) div n, y + textheight('H')-2);
end;

begin
  _setviewport(0,0,640,480,CLIPon);
  for i:=1 to pl do begin
    if (i mod 6 = 1) then begin
      _setviewport(0,0,640,480,CLIPon);
      settextjustify(lefttext, toptext);
      cleardevice;
      setfillstyle(1,C_BLACK);
      settextstyle(SansSerifFont, 0, 4);
      settextjustify(CenterText, CenterText);
      setcolor(C_WHITE);
      outtextxy(320,50, 'Medzivysledky proboja');
    end;

    _setviewport(40+280 * ((i-1) mod 2), 120+100*((((i-1) div 2) mod 3)),
                40+280 * ((i-1) mod 2+1), 120+100*(((((i-1) div 2)) mod 3)+1), true);
    settextjustify(lefttext, toptext);
    setcolor(INTERNAL_COLORS+i-1);
    settextstyle(SmallFont, 0, 6);
    outtextxy(0,0,stat.pl[i].meno);

    setcolor(C_LIGHTGRAY);
    str(stat.pl[i].body, s); outtextxy(ViewX-textwidth(s)-20, 0, s);

    settextstyle(SmallFont, 0, 4);
    setcolor(C_LIGHTGRAY);
    outtextxy(5,30+textheight('H')*0, 'Vyrobil');
    outtextxy(5,30+textheight('H')*1, 'Znicil');
    outtextxy(5,30+textheight('H')*3, 'Vojakov');
    outtextxy(5,30+textheight('H')*4, 'Statov');
    outtextxy(5,30+textheight('H')*5, 'Zon');

    tmax:=1;
    for j:=1 to pl do
      if statmax.pl[j].vyrobil>tmax then
        tmax:=statmax.pl[j].vyrobil;

    xbar(5+textwidth('Vojakov '),30+textheight('H')*0,
         statmax.pl[i].vyrobil, tmax);
    tmax:=1;
    for j:=1 to pl do
      if statmax.pl[j].znicil>tmax then
        tmax:=statmax.pl[j].znicil;

    xbar(5+textwidth('Vojakov '),30+textheight('H')*1,
         statmax.pl[i].znicil, tmax);
    tmax:=1;
    for j:=1 to pl do
      if statmax.pl[j].vojakov>tmax then
        tmax:=statmax.pl[j].vojakov;

    xbar(5+textwidth('Vojakov '),30+textheight('H')*3,
         statmax.pl[i].vojakov, tmax);
    tmax:=1;
    for j:=1 to pl do
      if statmax.pl[j].statov>tmax then
        tmax:=statmax.pl[j].statov;

    xbar(5+textwidth('Vojakov '),30+textheight('H')*4,
         statmax.pl[i].statov, tmax);
    tmax:=1;
    for j:=1 to pl do
      if statmax.pl[j].zon>tmax then
        tmax:=statmax.pl[j].zon;

    xbar(5+textwidth('Vojakov '),30+textheight('H')*5,
         statmax.pl[i].zon, tmax);
  end;

  _setviewport(0,0,getmaxx,getmaxy,CLIPoff);

end;

procedure gui_total_summary(pl:integer);
var idx:array[1..MAX_PLAYERS+1] of integer;
    i,j,k:integer;
    s:string;
    s1:string;
begin
  _setviewport(0,0,getmaxx,getmaxy,CLIPoff);
  cleardevice;
  setfillstyle(1,C_BLACK);

  settextstyle(SansSerifFont, 0, 4);
  settextjustify(CenterText, CenterText);
  setcolor(C_WHITE);
  outtextxy(320,50, 'Vysledky proboja');

  settextstyle(TriplexFont, 0, 5);

  for i:=1 to pl do
    idx[i]:=i;

  for i:=1 to 2*pl do
    for j:=1 to pl-1 do
      if (stat.pl[idx[j]].body<stat.pl[idx[j+1]].body) then
      begin
        k:=idx[j];
        idx[j]:=idx[j+1];
        idx[j+1]:=k;
      end;

{$b-}
  for i:=1 to pl do begin
    setcolor(C_LIGHTGRAY);
    settextjustify(righttext, centertext);
    str(stat.pl[idx[i]].body,s1);
    if (i=1) or (stat.pl[idx[i-1]].body<>stat.pl[idx[i]].body) then
      str(i,s)
    else
      s:=' ';
    outtextxy(150, 150+textheight('H')*(i-1)+5*(i-1), '('+s1+') '+s+'.');
    settextjustify(lefttext, centertext);
    setcolor(INTERNAL_COLORS+i-1);
    outtextxy(150, 150+textheight('H')*(i-1)+5*(i-1), stat.pl[idx[i]].meno);
  end;
end;




var i:integer;
begin

  for i:=0 to 255 do begin
    sprites[i].x1:=-1;
    sprites[i].x:=-1;
    sprites[i].y:=-1;
  end;

end.
