unit main;

interface

uses proboj0, gui;

{ globalny stav hry }
var
    zone : zone_rec;
    zon:integer;
    mapa : mapa_rec;
    staty : staty_rec;
    statov:integer;
    kolo : integer;

    act_player : phrac;

    novych : integer;
    tahov : integer;
    moze_utocit : boolean;

    last_dest : integer;
    last_atkz : integer;
    last_atkn : integer;

    znicil, vyrobil : integer;

    randseed_store : longint;

const
    MAX_MSG_DEPTH = 5;

    msg_depth : integer = MAX_MSG_DEPTH;


var
  player_no : integer;
  players : array[0..MAX_PLAYERS] of phrac;
  player_left_in : array[0..MAX_PLAYERS] of integer;
  player_score : array[0..MAX_PLAYERS] of longint;
  player_pocet_sprav : array[0..MAX_PLAYERS] of byte;
  players_cnt : integer;
  players_playing : integer;



procedure main_startup;

procedure loadmap(f : string);
function register_player(pl : phrac):boolean;

procedure main_shutdown;

procedure new_game;
procedure new_turn;

procedure loadmap_dump;

implementation

{ funkcie ovplyvnujuce pravidla hry }

function uprav_pocet_novych(p:integer):integer;
begin
  if (kolo>POCET_TAHOV0) then p:=(p+1) div 2;
  if (kolo>POCET_TAHOV1) then p:=(p+1) div 2;
  uprav_pocet_novych := p;
end;

function count_new:integer;
var novych:integer;
    maju:array[1..MAX_ZONES] of integer;
    i:integer;
begin
  novych:=PRIDAJ_ZAKLAD;

  fillchar(maju, sizeof(maju), 0);
  for i:=1 to zon do
    maju[i]:=-1;
  for i:=1 to statov do begin
    if maju[staty[i].zone]=-1 then
      maju[staty[i].zone]:=staty[i].owner
    else
    if maju[staty[i].zone]<>staty[i].owner then
      maju[staty[i].zone]:=-2;
  end;

  for i:=1 to zon do
    if (maju[i]=player_no) then
      inc(novych, zone[i].pridaj);
  count_new := uprav_pocet_novych(novych);
end;


procedure player_synchronize;
begin
  act_player^.zone := zone;
  act_player^.zon := zon;
  act_player^.mapa := mapa;
  act_player^.staty := staty;
  act_player^.statov := statov;
  act_player^.novych := novych;
  act_player^.tahov := tahov;
  act_player^.moze_utocit := moze_utocit;
  act_player^.kolo := kolo;
  act_player^.sprav := player_pocet_sprav[player_no];
end;


function check_pl(z:integer):boolean;
begin
  check_pl:=(z>=0) and (z<players_cnt);
end;

function check_st(z:integer):boolean;
begin
  check_st := (z>=1) and (z<=statov);
end;

procedure main_upd(z:integer);
var s : string;
begin
  str(staty[z].count, s);
  gui_sprite_upd(staty[z].id,s);
end;


{$f+}
function process_msg(cmd : word; z : integer; n : integer; c:integer; msg:string) : boolean;
var i:integer;
    k1, k2:integer;
    temp:longint;
    save_no : integer;
begin
  process_msg:=false;

  if (msg_depth<>MAX_MSG_DEPTH) and (cmd<>CMD_MSG) then exit;

  case cmd of
    CMD_UTOK:begin
               if (not (check_st(z) and check_st(n))) then exit;

               if (((moze_utocit or ((last_atkn=n) and (last_atkz=z))) and (staty[z].owner=player_no) and
                   (staty[z].count>1)) and (mapa[z][n]=1)) then
               begin
                 last_atkz := z;
                 last_atkn := n;
                 temp := randseed; randseed := randseed_store;
                 k1 := random(6);
                 k2 := random(6);
                 randseed_store := randseed; randseed:=temp;

                 gui_prepare_attack(staty[z].id, staty[n].id);

                 if (k1<k2) then
                 begin
                   { prehral nepriatelsky vojak }
                   dec(staty[n].count);
                   inc(znicil);
                   { obsad policko }
                   if (staty[n].count=0) then begin
                     staty[n].owner := player_no;
                     staty[n].count := 1;
                     dec(staty[z].count);
                     gui_conquer(staty[n].id, player_no);
                     main_upd(z);
                     main_upd(n);
                   end else
                     main_upd(n);
                 end
                 else begin
                   { prehrali sme ... }
                   dec(staty[z].count);
                   main_upd(z);
                 end;

                 { este synchronizovat mapu ... }
                 { novych:=count_new; - teraz uz nie }
                 moze_utocit := false;

                 player_synchronize;

                 process_msg := true;

                 { povedz ostatnym }
                 dec(msg_depth);
                 for i:=0 to players_cnt-1 do
                   if i<>player_no then
                     players[i]^.zautocil(player_no, z, n);
                 inc(msg_depth);

               end;
             end;
    CMD_TAHAJ:
             begin
               if (not (check_st(z) and check_st(n))) then exit;

               if (((tahov>0) and (staty[z].owner = player_no) and
                   (staty[n].owner = player_no) and
                   (staty[z].count > c) and
                   (staty[n].count+c<=MAX_VOJAKOV) and
                   (z <> last_dest)) and (c>0) and (mapa[z][n]=1)) then
               begin
                 if (z <> last_atkz) or (n<>last_atkn) then begin
                   last_dest := n;
                   dec(tahov);
                 end;

                 gui_prepare_move(staty[z].id, staty[n].id);
                 dec(staty[z].count, c);
                 inc(staty[n].count, c);
                 moze_utocit := false;

                 main_upd(z);
                 main_upd(n);

                 player_synchronize;

                 process_msg := true;

                 { povedz ostatnym }
                 dec(msg_depth);
                 for i:=0 to players_cnt-1 do
                   if i<>player_no then
                     players[i]^.potiahol(player_no, z, n);
                 inc(msg_depth);
               end;
               last_atkz:=-1;
               last_atkn:=-1;
             end;
    CMD_PRIDAJ:
             begin
               if (not check_st(n)) then exit;
               if ((novych>0) and (staty[n].count<MAX_VOJAKOV) and
                 (staty[n].owner = player_no)) then
               begin
                 gui_prepare_pridaj(staty[n].id);
                 inc(vyrobil);
                 inc(staty[n].count);
                 dec(novych);
                 main_upd(n);
                 player_synchronize;
                 process_msg := true;
                 { povedz ostatnym }
                 dec(msg_depth);
                 for i:=0 to players_cnt-1 do
                   if i<>player_no then
                     players[i]^.pridal(player_no, n);
                 inc(msg_depth);
               end;
             end;

    CMD_MSG: if (msg_depth>0) then begin
               if (z<>player_no) then exit;
               dec(msg_depth);
               if (not (check_pl(z) and
                    (check_pl(n) or (n=VSETKYM)))) then exit;

               if (n=VSETKYM) and (player_pocet_sprav[player_no]>0) then
                 begin
                   dec(player_pocet_sprav[player_no]);

                   player_synchronize;

                   gui_message(act_player^.meno, msg, player_no);

                   for i:=0 to players_cnt-1 do
                     if (i<>z) then begin
                       save_no := player_no; player_no:=i;
                       act_player := players[i];
                       players[i]^.prijmi(msg, z);
                       player_no:=save_no;
                     end;
                   act_player := players[player_no];
                   process_msg := true;
                 end
                 else
                   process_msg := false;

               inc(msg_depth);
             end;
    end;
end;
{$f-}


{ potiahni hracom }
procedure process_player(no : integer);
var i:integer;
    left : boolean;
begin
  player_no := no;               { nastav aktivneho playera }
  act_player := players[no];

  moze_utocit := true;           { stav na zaciatku tahu }
  tahov := 2;
  novych := count_new;

  znicil := 0;                   { }
  vyrobil := 0;

  player_pocet_sprav[player_no] := SPRAV_NA_KOLO;

  last_dest := -1;
  last_atkz := -1;
  last_atkn := -1;

  player_synchronize;            { syncni mapu a udaje }

  act_player^.novy_tah;          { urob tah ... }

  { zisti ci player opustil hru }
  left := true;
  for i:=1 to statov do
    if staty[i].owner = player_no then left := false;

  if left then begin
    player_left_in[player_no]:=kolo;
    dec(players_playing);
  end;

  { update znicil vyrobil }
  inc(stat.pl[player_no+1].znicil, znicil);
  inc(stat.pl[player_no+1].vyrobil, vyrobil);
end;

{ updatni statistiku }
procedure update_stat;
var i,j:integer;
    maju:array[1..MAX_ZONES] of integer;
begin
  

  for i:=0 to players_cnt-1 do begin
    player_no:=i;

    stat.pl[i+1].meno := players[i]^.meno;
    stat.pl[i+1].color := players[i]^.farba;
    stat.pl[i+1].vojakov := 0;
    stat.pl[i+1].statov := 0;
    for j:=1 to statov do
      if (staty[j].owner=i) then begin
        inc(stat.pl[i+1].vojakov, staty[j].count);
        inc(stat.pl[i+1].statov, staty[j].count);
      end;

    act_player:=players[i];
    stat.pl[i+1].zon := count_new;

    inc(player_score[i], stat.pl[i+1].vojakov);

    stat.pl[i+1].body := player_score[i];
  end;
  stat.kolo:=kolo;
end;


{ novy tah }
procedure new_turn;
var i:integer;
begin
  gui_next_turn;

  inc(kolo);                    { nove kolo }

  if players_playing > 1 then
    for i:=0 to players_cnt-1 do
      if (player_left_in[i] = -1) then
        process_player(i);      { potiahni kazdym hrajucim hracom }

  update_stat;                  { updatni statistiku }
  gui_update_stat(players_cnt);
end;

{ init new game }
procedure new_game;
var i,j,st:integer;
    p:array[1..MAX_PLAYERS] of integer;
begin
  randomize;
  randseed_store := randseed;

  { rozdel mapu medzi hracov }
  for j:=1 to statov do staty[j].owner := -1;

  for i:=1 to players_cnt do
    p[i]:=i-1;
  for i:=1 to players_cnt do begin
    j:=i+random(players_cnt-i+1);
    st:=p[i];
    p[i]:=p[j];
    p[j]:=st;
  end;

  st:=statov;
  repeat
    for i:=1 to players_cnt do begin

      repeat
        j := random(statov)+1;
      until staty[j].owner = -1;

      staty[j].owner := p[i];
      staty[j].count := VOJACI_ZAKLAD;
      gui_conquer(staty[j].id, staty[j].owner);
      main_upd(j);

      dec(st);

      if st=0 then break;

    end;

  until (st=0);

  players_playing := players_cnt;

  { nova hra pre kazdeho hraca }
  for i:=0 to players_cnt-1 do begin
    player_left_in[i] := -1;
    player_score[i]:=0;
    player_no:=i;
    act_player := players[i];
    novych := count_new;
    player_synchronize;
    player_pocet_sprav[i] := SPRAV_NA_KOLO;
    act_player^.nova_hra;
    stat.pl[i+1].znicil := 0;
    stat.pl[i+1].vyrobil := 0;
  end;

  { updatni statistiku }
  update_stat;
  gui_update_stat(players_cnt);

end;

{ clean old map }
procedure clean_all;
begin
  zon := 0; statov := 0; kolo:=0;
  fillchar(zone, sizeof(zone),0);
  fillchar(mapa, sizeof(mapa),0);
  fillchar(staty, sizeof(staty),0);
end;

{ register new player }
function register_player(pl : phrac):boolean;
begin
  if (players_cnt>=MAX_PLAYERS) then
    register_player := false
  else
    begin
      players[players_cnt]:=pl;

      pl^.init0(players_cnt, process_msg);

      inc(players_cnt);
    end;
end;

{ startup hry }
procedure main_startup;
begin
  players_cnt := 0;
end;

{ delete players }
procedure main_shutdown;
var i : integer;
begin
  for i:=0 to players_cnt-1 do
    dispose(players[i], done);
end;


{ === loader mapy ====================================================== }
{ meno zony -> id }
function zone_ref(s:string):integer;
var i:integer;
begin
  zone_ref := 0;
  for i:=1 to zon do
    if zone[i].meno = s then
      zone_ref:=i;
end;

{ meno statu -> id }
function state_ref(s:string):integer;
var i:integer;
begin
  state_ref := 0;
  for i:=1 to statov do
    if staty[i].meno = s then
      state_ref:=i;
end;

{ otestuj korektonost mapy }
procedure loadmap_tests;
var b:array[1..MAX_STATOV] of boolean;
    i,j,k:integer;
begin
  fillchar(b,sizeof(b),0);
  b[1]:=true;
  for i:=1 to MAX_STATOV do for j:=1 to MAX_STATOV do
    if b[j] then for k:=1 to MAX_STATOV do
      if mapa[j][k]=1 then b[k]:=true;

  for i:=1 to statov do
    if not b[i] then begin
      gui_shutdown;
      writeln('loadmap_test: Mapa nie je suvisla');
      halt(1);
    end;
end;

{ dumpni mapu }
procedure loadmap_dump;
var i,j:integer;
   t:text;
begin
  assign(t,'dump.txt');
  rewrite(t);

  writeln(t,i);
  for i:=1 to statov do begin
    writeln(t,staty[i].meno, ' ', chr(staty[i].id));
    writeln(t,zone[staty[i].zone].meno);
  end;

  writeln(t,';;;A teraz mapa');

  for i:=1 to statov do
    for j:=1 to statov do begin
      if (mapa[i][j]=1) then writeln(t,staty[i].meno, ' ', staty[j].meno);
    end;
  close(t);
end;

{ loadni mapu zo suboru f }
procedure loadmap(f : string);
var t : text;
    i,a,b:integer;
    s,s1,s2:string;
var j:integer;

procedure urob_mapu;
var i,j:integer;

procedure urov(c,d:byte);
var i:integer;
    n1, n2:integer;
begin
  n1:=-1; n2:=-1;
  if (c=ord('.')) or (d=ord('.')) then exit;
  n1 := -1;
  n2 := -1;
  for i:=1 to statov do begin
    if staty[i].id = c then n1:=i;
    if staty[i].id = d then n2:=i;
  end;

  if (n1=-1) or (n2=-1) then begin
    gui_shutdown;
    writeln('main_loadmap: nepoznam ',chr(c),chr(d));
    halt(1);
  end;

{ writeln(n1, ' ',n2);}
  mapa[n1][n2] := 1;
  mapa[n2][n1] := 1;
end;

begin
  for j:=1 to 68 do
  for i:=1 to 78 do begin
    if gui_mapa[j][i]<>gui_mapa[j-1][i] then
      urov(gui_mapa[j][i],gui_mapa[j-1][i]);
    if gui_mapa[j][i]<>gui_mapa[j+1][i] then
      urov(gui_mapa[j][i],gui_mapa[j+1][i]);
    if gui_mapa[j][i]<>gui_mapa[j][i-1] then
      urov(gui_mapa[j][i],gui_mapa[j][i-1]);
    if gui_mapa[j][i]<>gui_mapa[j][i+1] then
      urov(gui_mapa[j][i],gui_mapa[j][i+1]);
  end;
end;

procedure mapa_clean;
var i,j:integer;
begin
  for i:=1 to 68 do
  for j:=1 to 78 do begin
    if (gui_mapa[i][j] <> gui_mapa[i+1][j]) and
       (gui_mapa[i][j] <> gui_mapa[i-1][j]) and
       (gui_mapa[i][j] <> gui_mapa[i][j+1]) and
       (gui_mapa[i][j] <> gui_mapa[i][j-1]) then gui_mapa[i][j] := ord('.');
  end;
end;

procedure compute_t(color : byte; var x, y:integer);
var sx:real;
    sy:real;
    total:integer;
    i,j:integer;
begin
  sx:=0; sy:=0; total:=0;

  for i:=0 to 79 do
    for j:=0 to 69 do
      if (gui_mapa[j][i]=color) then begin
        sx:=sx+i; sy:=sy+j; inc(total);
      end;
  if (total=0) then begin
    gui_shutdown;
    writeln('MAIN: nemozem najst farbu ',chr(color));
    halt(1);
  end;
  x := round(sx/total);
  y := round(sy/total);
end;

procedure prerataj_vzdialenosti;
var i,j,k:integer;
begin
  for k:=1 to statov do
    for i:= 1 to statov do
      for j:= 1 to statov do
        if ((mapa[i,k]+mapa[k,j]<mapa[i,j]) or (mapa[i,j]=0)) and (mapa[i,k]<>0) and (mapa[k,j]<>0)
          then begin
            mapa[i,j] := mapa[i,k]+mapa[k,j];
            mapa[j,i] := mapa[i,k]+mapa[k,j];
          end;
end;


begin
  clean_all;
  assign(t, f+'.xmp');
  reset(t);
  for j:=0 to 69 do begin
    readln(t,s);
    for i:=0 to 79 do
      gui_mapa[j][i] := ord(s[i+1]);
  end;
  close(t);

  assign(t, f+'.xdf');
  reset(t);

  readln(t, zon);
  for i:=1 to zon do begin
    readln(t, zone[i].meno);
    readln(t, zone[i].pridaj);
  end;

  readln(t, statov);
  for i:=1 to statov do begin
    readln(t,staty[i].meno);
    readln(t,s);
    staty[i].zone := zone_ref(s);
    if (staty[i].zone=0) then begin
      gui_shutdown;
      writeln('MAIN: Invalid zone '+s);
      halt(1);
    end;
    readln(t,staty[i].x, staty[i].y);
    readln(t, s);
    staty[i].id := ord(s[1]);
    if (staty[i].x=-1) then
      begin
        compute_t(staty[i].id, staty[i].x, staty[i].y);
      end;
    gui_sprite_set(staty[i].id, staty[i].x, staty[i].y);
  end;

  readln(t,j);
  for i:=1 to j do begin
    readln(t,s1);
    s2 := s1;
    delete(s2, pos(' ', s1), 1000);
    delete(s1, 1, pos(' ', s1));
    a := state_ref(s1);
    b := state_ref(s2);
    if ((a=0) or (b=0)) then begin
      gui_shutdown;
      writeln('MAIN: Invalid state '+s1+' or '+s2);
      halt(1);
    end;
    mapa[a][b] := 1;
    mapa[b][a] := 1;
  end;

  urob_mapu;
  mapa_clean;

  loadmap_tests;

  close(t);

  prerataj_vzdialenosti;
end;



end.