unit proboj0;

interface

const
  MAX_PLAYERS = 10;             { maximalny pocet hracov }

  MAX_STATOV = 80;              { maximalny pocet statov na mape }
  MAX_ZONES = 10;               { maximalny pocet zon }

  PRIDAJ_ZAKLAD = 2;            { zaklad, ktory sa pridava za kazde kolo }
  VOJACI_ZAKLAD = 2;            { zaciatocny pocet vojakov na kazdom policku }
  MAX_VOJAKOV = 8;              { maximalny pocet vojakov na policku }

  POCET_TAHOV0 = 400;
  POCET_TAHOV1 = 500;

  SPRAV_NA_KOLO = 3;

  { internal - komunikacia s vyhodnocovacom tahov }
  CMD_UTOK = 0;
  CMD_TAHAJ = 1;
  CMD_PRIDAJ = 2;
  CMD_MSG = 3;

  VSETKYM = -1;


type
  send_msg_proc = function (cmd : word; z : integer; n : integer; c : integer; msg:string) : boolean;

  { vlastnosti statu }
  stat_rec = record
    meno : string[20];          { meno - nema vyznam }
    x,y : integer;              { miesto na mape }
    zone : integer;             { zona, do ktorej patri }
    owner : integer;            { majitel z rozsahu 0..pocet hracov }
    count : integer;            { pocet vojakov }
    id : byte;                  { interny identifikator }
  end;

  { vlastnosti zon }
  zone_rec = array [1..MAX_ZONES] of record
      meno:string[20];          { meno zony }
      pridaj:integer;           { pocet vojakov, ktory sa prida za dobytie zony }
  end;

  { mapa - mapa[i][j] je vzdialenost medzi statmi i a j }
  mapa_rec = array [1..MAX_STATOV, 1..MAX_STATOV] of byte;

  { vsetky staty }
  staty_rec = array [1..MAX_STATOV] of stat_rec;

  { genericky hrac }
  phrac = ^hrac;
  hrac = object
    meno : string;              { TN: meno hraca }
    id : integer;               { AT: id hraca - jeho policka sa oznacia tymto cislom }
    farba:longint;              { TN: farba hraca }
    msg : send_msg_proc;        { AT: internal }

    { stav hry }
    zone : zone_rec;            { AT: popis zon }
    zon : integer;              { AT: pocet zon }
    mapa : mapa_rec;            { AT: mapa - kto s kym susedi }
    staty : staty_rec;          { AT: stav statov }
    statov : integer;           { AT: pocet statov }
    novych : integer;           { AT: pocet novych vojakov, ktory sa mozu pridat }
    tahov : integer;            { AT: pocet tahov - tahaj }
    moze_utocit : boolean;      { AT: true ak moze utocit }
    kolo : integer;             { AT: cislo kola }
    sprav : integer;            { AT: kolko zostava sprav na poslanie v tomto kole }

    ps : string;
    ps_poslal : integer;



    constructor init;
    procedure init0(i : integer; send : send_msg_proc);
    { prikaz na utok z policka z na policko na }
    function utok(z : integer; na : integer) : boolean;
    { prikaz na potiahnutie vojakmi z policka z na policko na }
    function tahaj(z : integer; na : integer; kolko:integer) : boolean;
    { prikaz na pridanie vojaka na policko na }
    function pridaj(na : integer) : boolean;
    { prikaz na poslanie spravy co hracovi komu }
    function povedz(komu : integer; co : string) : boolean;
    { toto sa zavola iba raz - na zaciatku }
    procedure inicializuj; virtual;
    { toto sa zavola pri kazdej novej hre }
    procedure nova_hra; virtual;
    { toto sa zavola ak pride nejaka sprava }
    procedure prijmi(s:string; kto:integer); virtual;
    { toto sa vola kazdy tah }
    procedure novy_tah; virtual;

    { toto sa zavola vzdy, ako niekto zautoci }
    procedure zautocil(kto,z,na:integer); virtual;
    { toto sa zavola vzdy, ako niekto potiahne }
    procedure potiahol(kto,z,na:integer); virtual;
    { toto sa zavola vzdy, ako niekto prida vojaka }
    procedure pridal(kto,na:integer); virtual;


    destructor done; virtual;
  end;


implementation

constructor hrac.init;
begin
end;

procedure hrac.init0(i : integer; send : send_msg_proc);
begin
  str(i, meno);
  meno := 'HRAC-'+meno;
  farba := longint(random(128)+128)*65536 + longint(random(128)+128)*256 + random(128)+128;
  id := i;
  msg := send;
  inicializuj;
end;

procedure hrac.inicializuj;
begin
end;

procedure hrac.nova_hra;
begin
end;

function hrac.utok(z : integer; na : integer) : boolean;
begin
  utok:=msg(CMD_UTOK, z, na, 0, '');
end;
function hrac.tahaj(z : integer; na : integer; kolko:integer) : boolean;
begin
  tahaj:=msg(CMD_TAHAJ, z, na, kolko, '');
end;
function hrac.pridaj(na : integer) : boolean;
begin
  pridaj:=msg(CMD_PRIDAJ,0,na,0,'');
end;
function hrac.povedz(komu : integer; co : string) : boolean;
begin
  povedz:=msg(CMD_MSG, id,komu,0,co);
end;

procedure hrac.prijmi(s:string; kto:integer);
begin
  ps := s;
  ps_poslal := kto;
end;


procedure hrac.zautocil(kto,z,na:integer);
begin
end;

procedure hrac.potiahol(kto,z,na:integer);
begin
end;

procedure hrac.pridal(kto,na:integer);
begin
end;


procedure hrac.novy_tah;
begin
end;

destructor hrac.done;
begin
end;


end.
